      SUBROUTINE AFACAL
CCCCCC
      PARAMETER(NHS=9,NPS=9,LXA=150,LXB=150,LPH=20,LMM=4)
      PARAMETER(NXA=420,NXB=140,NIN=300)
CCCCCC
      COMMON/CNST  /FACLOG(500),PI,HBAR,AMAS,WNUNIT,FINE
      COMMON/CNTRL/ KTRLD(9),KTLOUT(24),KRTYPE
      COMMON/SPSTAT/EET,SPECTA(LPH),ESP(LPH),ESH(LPH),NSP(LPH),LSP(LPH),
     1              JTWP(LPH),NSH(LPH),LSH(LPH),JTWH(LPH),IPAIR,NOSP,
     2              NOSH,NPST(LPH),NHST(LPH),NPAIRD,L1R(8),ISR(8),
     3              ITR(8),NLSMAX,JT,MJMAX,KPARIT,IST,NOLTR,N1,LTR(8),
     4              ITP(LPH),ITH(LPH),ITZP(LPH),ITZH(LPH)
      COMMON/DWCC/  LDWMIR(4),LDWMXR(4),WN(4),LDWSTR(4),CE(4),CFUNIR(4),
     1              ECM(4),XMESR(4),NXMXR(4),NXMIR(4),NOEXP,MXSTEP,
     2              TMASA,TMASB,TMASX,TMASY,PMASA,PMASB,PMASX,PMASY,
     3              TZA,TZB,TZX,TZY,
     4              PZA,PZB,PZX,PZY,XBARD(4),XBARID(4)
      COMMON/SPECFC/ALPHA(30,6)
CCCCCC
      NLSKMX=NLSMAX*2
      DO 100 N1=1,NOLTR
      LT=LTR(N1)
      LTTW=LT*2
      DO  95 NLSK=1,NLSKMX
      K1=(NLSK-1)/NLSMAX
      K =K1*2
      NLS=NLSK-NLSMAX*K1
      IS=ISR(NLS)
      IT=ITR(NLS)
      L1=L1R(NLS)
      KTW=K*2
      ALPHA(NLSK,N1)=0.0
      IF(LT.GT.(K+L1).OR.LT.LT.IABS(K-L1)) GO TO 95
      IF(IS.EQ.0.AND.K.EQ.2) GO TO 95
      ISTW=IS*2
      L1TW=L1*2
      ISTTW=IST*2
      JTTW=JT*2
      IA=ISTTW
      IB=LTTW
      IC=IA
      ID=L1TW
      IE=JTTW
      IFF=KTW
      CALL RAC7(IA,IB,IC,ID,IE,IFF,FACLOG,RAC) 
      S1=1-2*MOD(L1+K+LT,2)
      C1=RAC*S1
      H1=IT*2+1
      HAT=SQRT(H1)
      IAMAS=PMASA+0.01
      IZA=PZA+0.01
      IZB=PZB+0.01
      INU=IZA-IZB
      IA=MOD(IAMAS,2)
      IB=IA
      IC=IT*2
      IF(KRTYPE.EQ.21) IB=IC
CCCCCC      KRTYPE = 21,     (D,2P) REACTION
      ID= IAMAS-IZA*2
      IE=-IAMAS+IZB*2
      IFF=ID+IE
      CALL CLEB(IA,IB,IC,ID,IE,IFF,FACLOG,RAC) 
      S1=1-2*MOD((IABS(IA+IC+IFF-ID))/2,2)
      C4=RAC*C1*S1/HAT
      C3=1.0
      IF(IAMAS-2) 90,20,30
   20 IA=2
      IB=ISTW
      IC=1
      ID=1
      IE=2
      IF(KRTYPE.EQ.21) IE=0
CCCCCC      KRTYPE = 21,     (D,2P) REACTION
      IFF=1
      CALL RAC7(IA,IB,IC,ID,IE,IFF,FACLOG,RAC) 
      H1SQ=(IE+1)*6
      H1=SQRT(H1SQ)
      C3=H1*RAC
      GO TO 90
   30 IF(IAMAS.GT.3) GO TO 40
      C3=(IT-1)*(IS-1)*4-(1-2*MOD(IT+IS,2))
      GO TO 90
   40 C3=2.0
   90 C5=C4*C3
      ALPHA(NLSK,N1)=C5
   95 CONTINUE
  100 CONTINUE
CCCCCC
      WRITE(8,800) 
      DO 120 NLT=1,NOLTR
      WRITE(8,802) NLT,(ALPHA(NLSK,NLT),NLSK=1,NLSKMX)
  120 CONTINUE
  800 FORMAT(/1H , 'ALPHA COEF. PROJ. SYSTEM IN EQ.(13) (AFACAL)'
     1   /1H , 'ALPHA(NLSK,NLT)=')
  802 FORMAT(1H ,5X,'NLT=',I3,2X,'ALPHA=',10E10.2/(21X,10E10.2))
CCCCCC
      RETURN
      END
CCCCCC
CCCCCC
      SUBROUTINE EFFINT(KEXCH)
CCCCCC
      PARAMETER(NXA=420,NXB=140,NIN=300)
CCCCCC
      COMMON/CNST  /FACLOG(500),PI,HBAR,AMAS,WNUNIT,FINE
      COMMON/CNTRL/ KTRLD(9),KTLOUT(24),KRTYPE
      COMMON/FFCC/  VRANG(6),VSTR(12,6),VV(NIN,12),XMESH,XMESHD,XMESHE,
     1              RHED(NIN),NBCMI,NBCMX,NONB,NBSTEP,LASTEP,LBSTEP,
     2              MXMAX,MP1MAX,NOLA,NOLB,INTRAN,KCETN(2),NONA,NONAH,
     3              NONAR,NASTEP,NHDMX,NHEMX,NGAUSR,NBSTPD,NBSTPE,
     4              N1STEP,JATW,ISATW
CCCCCC
      DIMENSION     L9(10)
CCCCCC
      SQFP=SQRT(PI*4.0)
      SQRT8=SQRT(8.0)
      ISTP=(INTRAN+9)/10
      DO 20 M1=1,12
      DO 20 NH=1,INTRAN
      VV(NH,M1)=0.
   20 CONTINUE
CCCCCC
      DO 100 K=1,6
      KTW=0
      IF(MOD(K,3).EQ.0) KTW=4
      K2=K
      IT=0
      IF(K2.GE.4) IT=1
      ITTW=IT*2
      IE=ITTW
      N2=(K2-1)/3
      K3=K2-N2*3
      H1=ITTW+1
      IS=K3/2
      ISTW=IS*2
      DO 92 NIS1=1,2
      IS1=NIS1-1
      IS1TW=IS1*2
      L9(1)=1
      L9(2)=1
      L9(3)=1
      L9(4)=1
      L9(5)=IS1TW
      L9(6)=IS1TW
      L9(7)=ISTW
      L9(8)=ISTW
      L9(9)=KTW
      CALL NINEJ(L9,FACLOG,U9)
      H1=ISTW+1
      H2=(IS1TW+1)*(ISTW+1)
      FAC2=U9*H2*SQRT(H1)
      DO 90 NIT1=1,2
      IT1=NIT1-1
      IT1TW=IT1*2
      L9(1)=1
      L9(2)=1
      L9(3)=1
      L9(4)=1
      L9(5)=IT1TW
      L9(6)=IT1TW
      L9(7)=ITTW
      L9(8)=ITTW
      L9(9)=0
      CALL NINEJ(L9,FACLOG,U9)
      H1=ITTW+1
      H2=(IT1TW+1)*(ITTW+1)
      FAC1=FAC2*U9*SQFP*H2*SQRT(H1)
      S2=1.0
      IF(KEXCH.EQ.1) S2=1-MOD(IT+IS+1,2)*2
      DO 70 NC=1,2
      M=(NC-1)*6+K
      M1=(NC-1)*6+IT1*3+KTW/4+IS1+1
      X=1.
      X=0.
      DO 60 NH=1,INTRAN
      X=X+XMESH
      IF(KEXCH.EQ.1) X=RHED(NH)
      X2=1.0
      IF(MOD(K,3).EQ.0.AND.KEXCH.EQ.0) X2=X*X*SQRT8
      IF(MOD(K,3).EQ.0.AND.KEXCH.EQ.1) X2=SQRT8
      IF(KTRLD(4).EQ.1.AND.MOD(K,3).EQ.0) X2=0.0
      DO 50 N=1,6
      IF (VRANG(N).EQ.0.0) GO TO 50    
      X1=X/VRANG(N)
      P1=VSTR(M,N)*EXP(-X1)/X1
      VV(NH,M1)=VV(NH,M1)+P1*X2*S2*FAC1
   50 CONTINUE
   60 CONTINUE
   70 CONTINUE
   90 CONTINUE
   92 CONTINUE
  100 CONTINUE
CCCCCC      
      IF (KTLOUT(3).NE.0) THEN
      WRITE(8,802) ISTP,INTRAN,M1
      DO 110 M1=1,12
      WRITE(8,805) M1,(VV(NH,M1),NH=ISTP,INTRAN,ISTP)
  110 CONTINUE
      ENDIF
  802 FORMAT(//1H ,5X,'VV(NH,M1),NH=ISTP(=',I3,'),INTRAN(=',I3,'),',
     1       'M1(=',I3,')  (EFFINT)')
  805 FORMAT(1H ,'M1=',I3,10E10.3)
CCCCCC
      RETURN
      END
CCCCCC
CCCCCC
      SUBROUTINE PDENST(KEXCH)
CCCCCC
      PARAMETER(NHS=9,NPS=9,LXA=150,LXB=150,LPH=20,LMM=4)
      PARAMETER(NXA=420,NXB=140,NIN=300)
CCCCCC      
      COMMON/CNST  /FACLOG(500),PI,HBAR,AMAS,WNUNIT,FINE
      COMMON/CNTRL/ KTRLD(9),KTLOUT(24),KRTYPE
      COMMON/DWCC/  LDWMIR(4),LDWMXR(4),WN(4),LDWSTR(4),CE(4),CFUNIR(4),
     1              ECM(4),XMESR(4),NXMXR(4),NXMIR(4),NOEXP,MXSTEP,
     2              TMASA,TMASB,TMASX,TMASY,PMASA,PMASB,PMASX,PMASY,
     3              TZA,TZB,TZX,TZY,
     4              PZA,PZB,PZX,PZY,XBARD(4),XBARID(4)
      COMMON/CGAUS/ NGAUS,NONE1,RTS(96),WGT(96),RA,RB,GKINT(20),
     1              GFT(200),VBS(120),VBE(120)
      COMMON/FFCC/  VRANG(6),VSTR(12,6),VV(NIN,12),XMESH,XMESHD,XMESHE,
     1              RHED(NIN),NBCMI,NBCMX,NONB,NBSTEP,LASTEP,LBSTEP,
     2              MXMAX,MP1MAX,NOLA,NOLB,INTRAN,KCETN(2),NONA,NONAH,
     3              NONAR,NASTEP,NHDMX,NHEMX,NGAUSR,NBSTPD,NBSTPE,
     4              N1STEP,JATW,ISATW
      COMMON/CDENS/ RHOD(NXA,NIN,LMM),USAVEX(4*NXA),SPEC(4),
     1              DENSTY(NXA),LAMMXD(3),LBXD(4),NOSTX
CCCCCC              NOTE: RHOD(N,NH,LAMP1) IS USED FOR BOTH PROJECTILE DIRECT
CCCCCC                    AND EXCHANGE MULTIPOLE DENSITIES
CCCCCC
      DIMENSION     P(130,30),PP(130,10)
      DIMENSION     C(100),PD(130,10)
      DIMENSION     SSUM(20),HATD(10)
      DOUBLE PRECISION  FFMU,RROOT
CCCCCC
      SQPAI=SQRT(PI)
      TWPAI=PI*2.0
      SQRT2=1./SQRT(2.0)
      ISTW=1
CCCCCC
      NGAUS=NGAUSR
      CALL GAUSF(NGAUS,RTS,WGT)
      XMES2=XMESR(3)
      G1=0.675
      LAMMAX=LAMMXD(2)
      LAMP1X=LAMMAX+1
      N2MAX=NXMXR(3)
      KEX2M1=N2MAX-1
      XMES2P=XMESR(3)
      JLSMAX=((LAMP1X+1)*LAMP1X)/2
CCCCCC
CCCCCC      NUCLEON SCATTERING
      KMAS=PMASA+0.001
      IF (KTRLD(1).EQ.3.OR.KMAS.EQ.1) RETURN
CCCCCC
CCCCCC      DIRECT TERM
      IF (KEXCH.EQ.0) GO TO 200
CCCCCC
CCCCCC     EXCHANGE DENSITIES FIRST
CCCCCC
      DO 13 N2=1,N2MAX
      DO 13 NH=1,NHEMX
      DO 13 JLS=1,LAMP1X
      RHOD(N2,NH,JLS)=0.0
   13 CONTINUE
      DO 100 N=1,NOSTX
      LBTR=LBXD(N)
      LP1MX=LBTR+1
      MP1MX=LP1MX
      FLBTW1=LBTR*2+1
      K=0
      JLS=0
      DO 20 LAMP1=1,LAMP1X
      LAMD=LAMP1-1
      NLDMX=LAMP1
      HLAMD=TWPAI/FLBTW1
      LD=LBTR-LAMD-2
      DO 20 NLD=1,NLDMX
      JLS=JLS+1
      LD=LD+2
      T2=FLOAT(LD*2+1)
      H1=SQRT(ABS(T2))
      HAT=H1*SQRT(FLBTW1)
      HATD(JLS)=HAT
      LDP1=LD+1
      IA=LD*2
      IB=LAMD*2
      IC=LBTR*2
      C1=1.0
      CALL CLEBZ(IA,IB,IC,FACLOG,RAC) 
      C1=RAC
      ID=0
      T1=1.0
      DO 19 M1=1,LAMP1
      K =K+1
      C(K)=0.0
      IF (LD.LT.0) GO TO 19
      IE=(M1-1)*2
      IFF=IE
      CALL CLEB(IA,IB,IC,ID,IE,IFF,FACLOG,RAC) 
      C(K)=RAC*T1*H1*HLAMD*C1
      T1=2.0
   19 CONTINUE
   20 CONTINUE
      JLSMAX=JLS
      RH=0.0
      XMESH=XMESHE
      DO 80 NH=1,NHEMX
      RH=RHED(NH)
      RHSQ=RH*RH
      R2P=0.0
      DO 70 N2P=1,N2MAX
      R2P=R2P+XMES2P
      R2PSQ=R2P*R2P
      R2PRH=R2P*RH*2.0
      DO 30 JLS=1,JLSMAX
   30 SSUM(JLS)=0.0
      DO 60 NG=1,NGAUS
      ROOT=RTS(NG)
      RROOT=ROOT 
      CALL YLCAL(RROOT,LAMP1X,LAMP1X,P)
      DO 34 LAMP1=1,LAMP1X
      DO 34 M1=1, LAMP1
   34 PD(LAMP1,M1)=P(LAMP1,M1)
      R2=SQRT(RHSQ+R2PSQ+R2PRH*ROOT)
      X2=R2/XMES2
      N2=X2
      IF (N2.LT.1) N2=1
      IF (N2.GT.KEX2M1) GO TO 60
      FN2=N2
      N2M=(N-1)*N2MAX+N2
      IF (KRTYPE.EQ.21) N2M=N2MAX+N2
      U2=USAVEX(N2M)+(USAVEX(N2M+1)-USAVEX(N2M))*(X2-FN2)
      U3=U2*WGT(NG)
      FMU=(R2P+RH*ROOT)/R2
      FFMU=FMU 
      CALL YLCAL(FFMU,LP1MX,MP1MX,P)
      J=0
      K=0
      DO 40 LAMP1=1,LAMP1X
      DO 40 NLD=1,LAMP1
      J=J+1
      DO 40 M1=1,LAMP1
      K=K+1
      SSUM(J)=SSUM(J)+C(K)*U3*P(LP1MX,M1)*PD(LAMP1,M1)
   40 CONTINUE
   60 CONTINUE
      JLS=0
      DO 65 LAMP1=1,LAMP1X
      DO 62 NLD=1,LAMP1
      JLS=JLS+1
      NL=LAMP1
      RHOD(N2P,NH,NL)=RHOD(N2P,NH,NL)+SSUM(JLS)*USAVEX(N2P)
     1                                        *SPEC(N)*HATD(JLS)
   62 CONTINUE
   65 CONTINUE
   70 CONTINUE
   80 CONTINUE
  100 CONTINUE
CCCCCC
      IF (KTLOUT(3).NE.0) THEN 
      ISTP=(NHEMX+9)/10
      DO 170 LAMP1=1,LAMP1X
      WRITE(8,810) LAMP1
      DO 160 N2=10,N2MAX,10
      WRITE(8,811) N2,(RHOD(N2,NH,LAMP1),NH=ISTP,NHEMX,ISTP)
  160 CONTINUE
  170 CONTINUE
      ENDIF
	RETURN
  810 FORMAT(//1H ,5X,'EXCHANGE DENSITY FOR LAMP1=',I2)
  811 FORMAT(1H ,'N2=',I3,7E10.2/(7X,7E10.2))
CCCCCC
CCCCCC      MULTIPOLE EXPANSION OF DIRECT DENSITY      CCCCCCC
CCCCCC
  200 LBTR=0
      LP1MX=1
      MP1MX=1
      FLBTW1=1
      C1=SQPAI
      RH=0.0
      XMESH=XMESHD
      DO 280 NH=1,NHDMX
      RH=RH+XMESH
      RHSQ=RH*RH
      R2P=.0
      DO 270 N2P=1,N2MAX
      R2P=R2P+XMES2P
      R2PSQ=R2P*R2P
      R2PRH=R2P*RH*2.0
      DO 230 JLS=1,LAMP1X
  230 SSUM(JLS)=0.0
      DO 260 NG=1,NGAUS
      ROOT=RTS(NG)
      RROOT=ROOT 
      CALL YLCAL(RROOT,LAMP1X,LAMP1X,P) 
      DO 234 LAMP1=1,LAMP1X
  234 PD(LAMP1,1)=P(LAMP1,1)
      R2=SQRT(RHSQ+R2PSQ+R2PRH*ROOT)
      X2=R2/XMES2
      N2=X2
      IF (N2.LT.1) N2=1
      IF (N2.GT.KEX2M1) GO TO 260
      FN2=N2
      U2=DENSTY(N2)+(DENSTY(N2+1)-DENSTY(N2))*(X2-FN2)
      U3=U2*WGT(NG)
      DO 240 LAMP1=1,LAMP1X
      J=LAMP1
      SSUM(J)=SSUM(J)+U3*PD(LAMP1,1)*C1
  240 CONTINUE
  260 CONTINUE
      DO 265 LAMP1=1,LAMP1X
      JLS=LAMP1
      RHOD(N2P,NH,JLS)=SSUM(JLS)
  265 CONTINUE
  270 CONTINUE
  280 CONTINUE
CCCCCC
      IF (KTLOUT(3).NE.0) THEN
      ISTP=(NHDMX+9)/10
      DO 370 LAMP1=1,LAMP1X
      WRITE(8,820) LAMP1
      DO 360 N2=10,N2MAX,10
      WRITE(8,811) N2, (RHOD(N2,NH,LAMP1),NH=ISTP,NHDMX,ISTP)
  360 CONTINUE
  370 CONTINUE
  820 FORMAT(//1H ,5X,'DIRECT DENSITY FOR LAMP1=',I2)
      ENDIF
CCCCCC
      RETURN
      END