      SUBROUTINE CROSS(FAC)
CCCCCC
      PARAMETER(NHS=9,NPS=9,LXA=150,LXB=150,LPH=20,LMM=4)
      PARAMETER(NXA=420,NXB=140,NIN=300)
      PARAMETER(KFM=10)
CCCCCC	
      COMMON/CNST  /FACLOG(500),PI,HBAR,AMAS,WNUNIT,FINE
      COMMON/CNTRL/ KTRLD(9),KTLOUT(24),KRTYPE
      COMMON/SPSTAT/EET,SPECTA(LPH),ESP(LPH),ESH(LPH),NSP(LPH),LSP(LPH),
     1              JTWP(LPH),NSH(LPH),LSH(LPH),JTWH(LPH),IPAIR,NOSP,
     2              NOSH,NPST(LPH),NHST(LPH),NPAIRD,L1R(8),ISR(8),
     3              ITR(8),NLSMAX,JT,MJMAX,KPARIT,IST,NOLTR,N1,LTR(8),
     4              ITP(LPH),ITH(LPH),ITZP(LPH),ITZH(LPH)
      COMMON/DWCC/  LDWMIR(4),LDWMXR(4),WN(4),LDWSTR(4),CE(4),CFUNIR(4),
     1              ECM(4),XMESR(4),NXMXR(4),NXMIR(4),NOEXP,MXSTEP,
     2              TMASA,TMASB,TMASX,TMASY,PMASA,PMASB,PMASX,PMASY,
     3              TZA,TZB,TZX,TZY,
     4              PZA,PZB,PZX,PZY,XBARD(4),XBARID(4),WNXD(20),EXPD(20)
      COMMON/RELKIN/RMASA,RMASB,TREL1,TREL2,OMEGR(20)
      COMMON/FFCC/  VRANG(6),VSTR(12,6),VV(NIN,12),XMESH,XMESHD,XMESHE,
     1              RHED(NIN),NBCMI,NBCMX,NONB,NBSTEP,LASTEP,LBSTEP,
     2              MXMAX,MP1MAX,NOLA,NOLB,INTRAN,KCETN(2),NONA,NONAH,
     3              NONAR,NASTEP,NHDMX,NHEMX,NGAUSR,NBSTPD,NBSTPE,
     4              N1STEP,JATW,ISATW
      COMMON/CCKF/  L1KFD(KFM),ISKFD(KFM),KKFD(KFM),LTKFD(KFM),KFMAX,
     1              ITKFD(KFM),NLSKFD(KFM),NLTKFD(KFM),LTMIM,LTMAX
      COMMON/ANGCC/ THEB,THEBMX,DTHEB,THMIN,THMAX,THIND
      COMMON/OVDE/  OVDD(50,10,10),OVED(50,10,10),TH(50),DELWN(50)
      COMPLEX       OVDD,OVED                               
      COMMON/CPWFAC/TFAC(3,10,10),FACNR,LRP1MX
CCCCCC
      DIMENSION     CROSD(50,20,4),TCROST(50),TCROSD(50),TCROSE(50) 
      DIMENSION     LTOUT(89)
      COMPLEX       OV1,OV2,OV3,TTI,ZERO
CCCCC
CCCCC     NOTE THAT THIS PROGRAM ALLOWS ONLY ONE SET OF IS1
CCCCC
      ZERO=(0.0,0.0)
      TTI=(0.0,1.0)
      KOUT=KTLOUT(6)
      HBRSQ=HBAR*HBAR
      CONV=180.0/PI
      LAP1MI=LDWMIR(1)+1
      LAP1MX=LDWMXR(1)+1
      LASTEP=LDWSTR(1)
      IF(LASTEP.EQ.0) LASTEP=1
      LBP1MI=LDWMIR(2)+1
      LBP1MX=LDWMXR(2)+1
      LBSTEP=LDWSTR(2)
      IF(LBSTEP.EQ.0) LBSTEP=1
      NOLB=(LBP1MX-LBP1MI)/LBSTEP+1
      NOLA=(LAP1MX-LAP1MI)/LASTEP+1
      LAP1MX=LAP1MI+(NOLA-1)*LASTEP
      MXP1MX=MIN0(LTMAX,MXMAX)+1
      JTTW=JT*2
      ISTTW=IST*2
      KFMAX=NOLTR
CCCCC
CCCCC           TRANSITION DENSITIES
CCCCC
      IF(KTRLD(9).EQ.1) THEN
      REL1=(4.0*PI/(WN(1)*WN(2)))**2
      T1=10.*(WN(2)/WN(1))/(TREL1*TREL2*REL1)
      ELSE
      T1 =((AMAS/(2.0*PI*HBRSQ))**2)*RMASA*RMASA*10.0*WN(2)/WN(1)
      ENDIF
CCCCCC
      FLASTP=FLOAT(LASTEP*LASTEP)
      T2=1.0/FLOAT((JATW+1)*(ISATW+1))
      T3=FLOAT(JT*2+1)
      FAC=T1*FLASTP*T2*T3*0.8400
      NTHETA=(THEBMX-THEB)/DTHEB+1. 
	IF (KTRLD(1).EQ.1) NTHETA=1
      DO 905 NTH=1,NTHETA 
	TCROST(NTH)=0.0
      TCROSD(NTH)=0.0     
      TCROSE(NTH)=0.0 
 905  CONTINUE
	DO 950 NTH=1,NTHETA
      TH(NTH)=THEB+FLOAT(NTH-1)*DTHEB
	THETA= TH(NTH)*PI/180.0
	DELWN(NTH)=SQRT(WN(1)**2+WN(2)**2-2.0*WN(1)*WN(2)*COS(THETA))
      DO 910 LTM=1,NOLTR
         CROSD(NTH,LTM,1)=0.0
         CROSD(NTH,LTM,2)=0.0
         CROSD(NTH,LTM,3)=0.0
 910  CONTINUE
      DO 915 LTM=1,NOLTR
         LTP1=LTR(LTM)+1
         LT1=LTP1-1
         LTOUT(LTM)=LTP1-1
         SCROS=0.0
         SCROSD=0.0
         SCROSE=0.0
         F1=1.0
         MP1XT=MIN0(LTP1,MP1MAX)
         DO 912 MP1=1,MP1XT
            OV3=OVED(NTH,LTM,MP1)
            OV2=OVDD(NTH,LTM,MP1)
            OV1=OV2+OV3
            OV1R=REAL(OV1)
            OV1I=AIMAG(OV1)
            OV2R=REAL(OV2)
            OV2I=AIMAG(OV2)
            OV3R=REAL(OV3)
            OV3I=AIMAG(OV3)
            T1=(OV1R**2+OV1I**2)*F1
            T2=(OV2R**2+OV2I**2)*F1
            T3=(OV3R**2+OV3I**2)*F1
            SCROS =SCROS +T1
            SCROSD=SCROSD+T2
            SCROSE=SCROSE+T3
            F1=2.0
  912    CONTINUE
         CROSD(NTH,LTM,1)=SCROS *FAC
         CROSD(NTH,LTM,2)=SCROSD*FAC
         CROSD(NTH,LTM,3)=SCROSE*FAC
         TCROST(NTH) = TCROST(NTH) + CROSD(NTH,LTM,1)
	   TCROSD(NTH) = TCROSD(NTH) + CROSD(NTH,LTM,2)
	   TCROSE(NTH) = TCROSE(NTH) + CROSD(NTH,LTM,3)
  915 CONTINUE
  950 CONTINUE
CCCCCC
      WRITE(8,842)
      DO 960 LTM=1,NOLTR
      LT=LTR(LTM)
      WRITE(8,840) LT
      DO 955 NTH=1,NTHETA
	WRITE(8,841) TH(NTH), DELWN(NTH), 
     1             CROSD(NTH,LTM,2),CROSD(NTH,LTM,3),CROSD(NTH,LTM,1)
  955 CONTINUE
  960 CONTINUE
  840 FORMAT(/1H ,'LT=',I3,' CONTRIBUTION TO THE CROSS SECTIONS'
     1        /1H , '  CM ANGLE MOM. TRANS   DIRECT  EXCHANGE   TOTAL')
  841 FORMAT(1H ,10E10.3)
  842 FORMAT(///1H ,'FINAL DIFFERENTIAL CROSS SECTIONS') 
      WRITE(8,850)
      DO 970 NTH=1,NTHETA
	WRITE(8,841) TH(NTH), DELWN(NTH), 
     1             TCROSD(NTH),TCROSE(NTH),TCROST(NTH)
  970 CONTINUE
  850 FORMAT(//1H ,'TOTAL CROSS SECTIONS'
     1        /1H , '  CM ANGLE MOM. TRANS   DIRECT  EXCHANGE   TOTAL')
CCCCCC
      RETURN
      END
